/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM calIIcsSerializer.idl
 */

#ifndef __gen_calIIcsSerializer_h__
#define __gen_calIIcsSerializer_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class calIIcalProperty; /* forward declaration */

class calIIcalComponent; /* forward declaration */

class calIItemBase; /* forward declaration */

class nsIOutputStream; /* forward declaration */

class nsIInputStream; /* forward declaration */


/* starting interface:    calIIcsSerializer */
#define CALIICSSERIALIZER_IID_STR "4dcf6b4e-7322-4a61-a191-8d8cc1aea42e"

#define CALIICSSERIALIZER_IID \
  {0x4dcf6b4e, 0x7322, 0x4a61, \
    { 0xa1, 0x91, 0x8d, 0x8c, 0xc1, 0xae, 0xa4, 0x2e }}

/**
 * An interface for serializing calendar items into an ICS string.
 * Note that this is not a service. A new instance must be created for every new
 * set of items to be serialized.
 */
class NS_NO_VTABLE calIIcsSerializer : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALIICSSERIALIZER_IID)

  /**
   * Add some items to the items that are to be serialized. Can be called
   * multiple times, and appends to the set on every call.
   *
   * @param aItems
   *    The items to be added
   * @param aCount
   *    The number of items to add
   */
  /* void addItems ([array, size_is (aCount)] in calIItemBase aItems, in unsigned long aCount); */
  NS_IMETHOD AddItems(calIItemBase **aItems, PRUint32 aCount) = 0;

  /**
   * Add a property to the top-level properties to be added on serializing. Can
   * be called multiple times, and appends to the set on every call.
   *
   * @param aProperty
   *    The property to be added
   */
  /* void addProperty (in calIIcalProperty aProperty); */
  NS_IMETHOD AddProperty(calIIcalProperty *aProperty) = 0;

  /**
   * Add a component to the top-level components to be added on serializing. Can
   * be called multiple times, and appends to the set on every call.
   *
   * @param aComponent
   *    The component to be added
   */
  /* void addComponent (in calIIcalComponent aComponent); */
  NS_IMETHOD AddComponent(calIIcalComponent *aComponent) = 0;

  /**
   * Serialize the added items, properties and components into an ICS string
   *
   * @returns
   *    A string containing the serialized items, properties and components.
   */
  /* AString serializeToString (); */
  NS_IMETHOD SerializeToString(nsAString & _retval) = 0;

  /**
   * Serialize the added items, properties and components into an ICS stream
   *
   * @returns
   *    A stream containing the serialized items, properties and components.
   */
  /* nsIInputStream serializeToInputStream (); */
  NS_IMETHOD SerializeToInputStream(nsIInputStream **_retval) = 0;

  /**
   * Serialize the added items, properties and components into an ICS stream
   *
   * @param aStream
   *    A stream into which the serialized items, properties and components
   *    will be written.
   */
  /* void serializeToStream (in nsIOutputStream aStream); */
  NS_IMETHOD SerializeToStream(nsIOutputStream *aStream) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALIICSSERIALIZER \
  NS_IMETHOD AddItems(calIItemBase **aItems, PRUint32 aCount); \
  NS_IMETHOD AddProperty(calIIcalProperty *aProperty); \
  NS_IMETHOD AddComponent(calIIcalComponent *aComponent); \
  NS_IMETHOD SerializeToString(nsAString & _retval); \
  NS_IMETHOD SerializeToInputStream(nsIInputStream **_retval); \
  NS_IMETHOD SerializeToStream(nsIOutputStream *aStream); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALIICSSERIALIZER(_to) \
  NS_IMETHOD AddItems(calIItemBase **aItems, PRUint32 aCount) { return _to AddItems(aItems, aCount); } \
  NS_IMETHOD AddProperty(calIIcalProperty *aProperty) { return _to AddProperty(aProperty); } \
  NS_IMETHOD AddComponent(calIIcalComponent *aComponent) { return _to AddComponent(aComponent); } \
  NS_IMETHOD SerializeToString(nsAString & _retval) { return _to SerializeToString(_retval); } \
  NS_IMETHOD SerializeToInputStream(nsIInputStream **_retval) { return _to SerializeToInputStream(_retval); } \
  NS_IMETHOD SerializeToStream(nsIOutputStream *aStream) { return _to SerializeToStream(aStream); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALIICSSERIALIZER(_to) \
  NS_IMETHOD AddItems(calIItemBase **aItems, PRUint32 aCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddItems(aItems, aCount); } \
  NS_IMETHOD AddProperty(calIIcalProperty *aProperty) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddProperty(aProperty); } \
  NS_IMETHOD AddComponent(calIIcalComponent *aComponent) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddComponent(aComponent); } \
  NS_IMETHOD SerializeToString(nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SerializeToString(_retval); } \
  NS_IMETHOD SerializeToInputStream(nsIInputStream **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SerializeToInputStream(_retval); } \
  NS_IMETHOD SerializeToStream(nsIOutputStream *aStream) { return !_to ? NS_ERROR_NULL_POINTER : _to->SerializeToStream(aStream); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calIIcsSerializer
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALIICSSERIALIZER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calIIcsSerializer)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void addItems ([array, size_is (aCount)] in calIItemBase aItems, in unsigned long aCount); */
NS_IMETHODIMP _MYCLASS_::AddItems(calIItemBase **aItems, PRUint32 aCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addProperty (in calIIcalProperty aProperty); */
NS_IMETHODIMP _MYCLASS_::AddProperty(calIIcalProperty *aProperty)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addComponent (in calIIcalComponent aComponent); */
NS_IMETHODIMP _MYCLASS_::AddComponent(calIIcalComponent *aComponent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString serializeToString (); */
NS_IMETHODIMP _MYCLASS_::SerializeToString(nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInputStream serializeToInputStream (); */
NS_IMETHODIMP _MYCLASS_::SerializeToInputStream(nsIInputStream **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void serializeToStream (in nsIOutputStream aStream); */
NS_IMETHODIMP _MYCLASS_::SerializeToStream(nsIOutputStream *aStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_calIIcsSerializer_h__ */
